找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 3103|回复: 18

[教学] 对称拉伸

[复制链接]

已领礼包: 1268个

财富等级: 财源广进

发表于 2014-3-1 16:52:33 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
本帖最后由 st788796 于 2014-3-1 16:57 编辑

  1. (defun c:tt (/ Pnts:Mirror _pi2 p1 p2 p pts ptl p3 p4 p33 p44 _stretch)
  2.   (defun Pnt:Mirror (pt p1 p2 / p an)
  3.     (setq an (angle p1 p2)
  4.           p  (inters p1 p2 pt (polar pt (+ an _pi2) 1.) nil)
  5.     )
  6.     (polar pt (angle pt p) (* (distance pt p) 2.))
  7.   )
  8.   (defun _stretch (pts p1 p2 / tf)
  9.     (vl-cmdf ".stretch" "CP")
  10.     (while (and pts (/= (getvar "cmdactive") 0))
  11.       (vl-cmdf (car pts))
  12.       (setq pts (cdr pts))
  13.     )
  14.     (vl-cmdf "")
  15.     (vl-cmdf "")
  16.     (vl-cmdf p1)
  17.     (vl-cmdf p2)
  18.   )
  19.   (setq _pi2 (* pi 0.5))
  20.   (if (and (setq p1 (getpoint "\nFirst Point of Mirror line: "))
  21.            (setq p2 (getpoint p1 "\nSecond Point of Mirror Line: "))
  22.            (progn
  23.              (grdraw p1 p2 6 1)
  24.              (while (setq p (if        pts
  25.                               (getpoint (car pts) "\nNext Point: ")
  26.                               (getpoint "\nFirst Point: ")
  27.                             )
  28.                     )
  29.                (if pts
  30.                  (progn
  31.                    (grdraw p (car pts) 1 1)
  32.                    (grdraw (pnt:mirror p p1 p2)
  33.                            (car ptl)
  34.                            1
  35.                            1
  36.                    )
  37.                  )
  38.                )
  39.                (setq pts (cons p pts)
  40.                      ptl (cons (pnt:mirror p p1 p2) ptl)
  41.                )
  42.              )
  43.              (grdraw (car pts) (last pts) 1 1)
  44.              (grdraw (car ptl) (last ptl) 1 1)
  45.              pts
  46.            )
  47.            (> (length pts) 2)
  48.            (setq p3 (getpoint "\nBase Point: "))
  49.            (setq p4 (getpoint p3 "\nTarget Point: "))
  50.       )
  51.     (progn
  52.       (setq p33        (pnt:mirror p3 p1 p2)
  53.             p44        (pnt:mirror p4 p1 p2)
  54.       )
  55.       (_stretch pts p3 p4)
  56.       (_stretch ptl p33 p44)
  57.     )
  58.   )
  59.   (princ)
  60. )
mstretch.gif
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 685个

财富等级: 财运亨通

发表于 2014-3-1 17:56:41 | 显示全部楼层
提点小意见~~~~~
确定对称轴后
拉伸操作改为直接框选是不是更方便??
要画线选对象还不如直接来两次S(拉伸)快啊

(或许这不好实现)

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 1268个

财富等级: 财源广进

 楼主| 发表于 2014-3-1 18:16:07 | 显示全部楼层
本帖最后由 st788796 于 2014-3-1 18:52 编辑
ysq101 发表于 2014-3-1 17:56
提点小意见~~~~~
确定对称轴后
拉伸操作改为直接框选是不是更方便??

框选简单啊,GetCorner
  1. (defun c:tt (/ Pnts:Mirror _pi2 p1 p2 p3 p4 p00 p01 p000 p001 _stretch)
  2.   (defun Pnt:Mirror (pt p1 p2 / p an)
  3.     (setq an (angle p1 p2)
  4.           p  (inters p1 p2 pt (polar pt (+ an _pi2) 1.) nil)
  5.     )
  6.     (polar pt (angle pt p) (* (distance pt p) 2.))
  7.   )
  8.   (setq _pi2 (* pi 0.5))
  9.   (if (and (setq p1 (getpoint "\nFirst Point of Mirror line: "))
  10.            (setq p2 (getpoint p1 "\nSecond Point of Mirror Line: "))
  11.            (progn
  12.              (grdraw p1 p2 6 1)
  13.              t
  14.            )
  15.            (setq p00 (getpoint "\nFirst Corner: "))
  16.            (setq p01 (getcorner p00 "\nSecond Corner: "))
  17.            (progn
  18.              (grvecs (list '1
  19.                            p00
  20.                            (list (car p01) (cadr p00) 0.)
  21.                            '1
  22.                            (list (car p01) (cadr p00) 0.)
  23.                            p01
  24.                            '1
  25.                            p01
  26.                            (list (car p00) (cadr p01) 0.)
  27.                            '1
  28.                            (list (car p00) (cadr p01) 0.)
  29.                            p00
  30.                      )
  31.              )
  32.              (setq p000        (pnt:mirror p00 p1 p2)
  33.                    p001        (pnt:mirror p01 p1 p2)
  34.              )
  35.              (grvecs (list '1
  36.                            p000
  37.                            (list (car p001) (cadr p000) 0.)
  38.                            '1
  39.                            (list (car p001) (cadr p000) 0.)
  40.                            p001
  41.                            '1
  42.                            p001
  43.                            (list (car p000) (cadr p001) 0.)
  44.                            '1
  45.                            (list (car p000) (cadr p001) 0.)
  46.                            p000
  47.                      )
  48.              )
  49.              t
  50.            )
  51.            (setq p3 (getpoint "\nBase Point: "))
  52.            (setq p4 (getpoint p3 "\nTarget Point: "))
  53.       )
  54.     (progn
  55.       (vl-cmdf "._stretch" "C" "_none" p00 "_none" p01 "" "_none" p3
  56.                "_none" p4)

  57.       (vl-cmdf "._stretch"
  58.                "C"
  59.                "_none"
  60.                p000
  61.                "_none"
  62.                p001
  63.                ""
  64.                "_none"
  65.                (pnt:mirror p3 p1 p2)
  66.                "_none"
  67.                (pnt:mirror p4 p1 p2)
  68.       )
  69.     )
  70.   )
  71.   (princ)
  72. )

点评

感谢分享学习!  详情 回复 发表于 2014-3-4 17:31
突然来点灵感 指定对称轴的时候可以直接 点选 中心线啊~~~~ 这样就免去点两下了哈。。。。 实在不行我自己改改吧。。。反正是源码,,就当是学习一下好了  详情 回复 发表于 2014-3-1 21:34
感谢你采纳我的建议~~~~这个功能真心不错啊。。。。很多行业都通用 再次谢谢你  详情 回复 发表于 2014-3-1 19:55
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 1336个

财富等级: 财源广进

发表于 2014-3-1 19:19:02 | 显示全部楼层
一箭双雕。喜欢100%lisp.学习了!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 685个

财富等级: 财运亨通

发表于 2014-3-1 19:55:27 | 显示全部楼层
st788796 发表于 2014-3-1 18:16
框选简单啊,GetCorner

感谢你采纳我的建议~~~~这个功能真心不错啊。。。。很多行业都通用
再次谢谢你
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 394个

财富等级: 日进斗金

发表于 2014-3-1 19:56:20 | 显示全部楼层
这个牛,顶一下,画工件方便多了.
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 1332个

财富等级: 财源广进

发表于 2014-3-1 20:51:25 | 显示全部楼层
本帖最后由 maxone 于 2014-3-1 20:52 编辑

载入之后出现这个,错误: 读入的 (八进制) 字符不正确: 0:L

点评

还出现: 错误: no function definition: 八进制  发表于 2014-3-3 00:38
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 685个

财富等级: 财运亨通

发表于 2014-3-1 21:34:11 | 显示全部楼层
st788796 发表于 2014-3-1 18:16
框选简单啊,GetCorner

突然来点灵感
指定对称轴的时候可以直接   点选   中心线啊~~~~

这样就免去点两下了哈。。。。

实在不行我自己改改吧。。。反正是源码,,就当是学习一下好了
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 1268个

财富等级: 财源广进

 楼主| 发表于 2014-3-1 21:50:15 | 显示全部楼层
ysq101 发表于 2014-3-1 21:34
突然来点灵感
指定对称轴的时候可以直接   点选   中心线啊~~~~

有线时当然可以, 没有时还得描点

点评

对于这种对称图。。。一般作图者都会作出中心线不过你说得也是有道理。。。。。。。个人习惯不一样。。。 还是我自己动手改改吧。。。 谢谢你  详情 回复 发表于 2014-3-1 21:53
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 685个

财富等级: 财运亨通

发表于 2014-3-1 21:53:26 | 显示全部楼层
st788796 发表于 2014-3-1 21:50
有线时当然可以, 没有时还得描点

对于这种对称图。。。一般作图者都会作出中心线不过你说得也是有道理。。。。。。。个人习惯不一样。。。

还是我自己动手改改吧。。。

谢谢你


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 343个

财富等级: 日进斗金

发表于 2014-3-3 21:43:30 | 显示全部楼层
机械佬专用
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 8675个

财富等级: 富甲天下

发表于 2014-3-4 17:31:22 | 显示全部楼层
st788796 发表于 2014-3-1 18:16
框选简单啊,GetCorner

感谢分享学习!{:soso_e179:}

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 55个

财富等级: 招财进宝

发表于 2014-3-9 16:22:41 | 显示全部楼层
这样还是省事不少:)
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2015-7-26 21:52:21 | 显示全部楼层
这个实用,不知道怎么用?
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2015-7-26 21:53:57 | 显示全部楼层
这个实用,不知道怎么用?
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-2-24 21:22 , Processed in 0.430957 second(s), 60 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2023 Discuz! Team.

快速回复 返回顶部 返回列表